<template>
  <div class="ob_notification_container">
    <div class="ob_notification_container_left">
      <div
        class="ob_notification_item_card"
        v-for="(item, key) in leftList"
        :key="key"
      >
        <transition-group name="notify-left">
          <div
            :class="`ob_notification_item ${item.type}`"
            :key="key"
          >
            <i v-if="item.type === 'system_notification_success' || item.type === 'system_notification_error'"
               class="icon" :class="icons[item.type]" />
            <span
              v-if="item.type === 'system_notification_in_load'"
              class="ob_load_animation"
            >
              <svg
                xmlns="http://www.w3.org/2000/svg" xmlns:xlink="http://www.w3.org/1999/xlink"
                style="margin: 0; background: none; display: block; shape-rendering: auto;" width="36px"
                height="36px" viewBox="0 0 100 100" preserveAspectRatio="xMidYMid"
              >
                <g transform="rotate(0 50 50)">
                  <rect x="45.5" y="29.5" rx="4.5" ry="4.5" width="9" height="9" fill="#ffffff">
                    <animate attributeName="opacity" values="1;0" keyTimes="0;1" dur="1.333333333333333s"
                             begin="-1.1666666666666665s" repeatCount="indefinite"/>
                  </rect>
                </g><g transform="rotate(45 50 50)">
                  <rect x="45.5" y="29.5" rx="4.5" ry="4.5" width="9" height="9" fill="#ffffff">
                    <animate attributeName="opacity" values="1;0" keyTimes="0;1" dur="1.333333333333333s"
                             begin="-0.9999999999999999s" repeatCount="indefinite"/>
                  </rect>
                </g><g transform="rotate(90 50 50)">
                  <rect x="45.5" y="29.5" rx="4.5" ry="4.5" width="9" height="9" fill="#ffffff">
                    <animate attributeName="opacity" values="1;0" keyTimes="0;1" dur="1.333333333333333s"
                             begin="-0.8333333333333333s" repeatCount="indefinite"/>
                  </rect>
                </g><g transform="rotate(135 50 50)">
                  <rect x="45.5" y="29.5" rx="4.5" ry="4.5" width="9" height="9" fill="#ffffff">
                    <animate attributeName="opacity" values="1;0" keyTimes="0;1" dur="1.333333333333333s"
                             begin="-0.6666666666666665s" repeatCount="indefinite"/>
                  </rect>
                </g><g transform="rotate(180 50 50)">
                  <rect x="45.5" y="29.5" rx="4.5" ry="4.5" width="9" height="9" fill="#ffffff">
                    <animate attributeName="opacity" values="1;0" keyTimes="0;1" dur="1.333333333333333s"
                             begin="-0.49999999999999994s" repeatCount="indefinite"/>
                  </rect>
                </g><g transform="rotate(225 50 50)">
                  <rect x="45.5" y="29.5" rx="4.5" ry="4.5" width="9" height="9" fill="#ffffff">
                    <animate attributeName="opacity" values="1;0" keyTimes="0;1" dur="1.333333333333333s"
                             begin="-0.33333333333333326s" repeatCount="indefinite"/>
                  </rect>
                </g><g transform="rotate(270 50 50)">
                  <rect x="45.5" y="29.5" rx="4.5" ry="4.5" width="9" height="9" fill="#ffffff">
                    <animate attributeName="opacity" values="1;0" keyTimes="0;1" dur="1.333333333333333s"
                             begin="-0.16666666666666663s" repeatCount="indefinite"/>
                  </rect>
                </g><g transform="rotate(315 50 50)">
                  <rect x="45.5" y="29.5" rx="4.5" ry="4.5" width="9" height="9" fill="#ffffff">
                    <animate attributeName="opacity" values="1;0" keyTimes="0;1" dur="1.333333333333333s"
                             begin="0s" repeatCount="indefinite"/>
                  </rect>
                </g>
              </svg>
            </span>

            <i
              v-if="item.type === 'snackbars'"
              class="icon close"
              @click="closeNotify(item)"
            />

            <span v-html="item.message" />

            <template v-if="item.onclick">
              <a
                @click="actionNotify(item)"
                class="ob_notification_container_action"
              >
                {{ item.onclick.label }}
              </a>
            </template>
          </div>
        </transition-group>
      </div>
    </div>

    <div class="ob_notification_container_right">
      <div
        class="ob_notification_item_card"
        v-for="(item, key) in rightList"
        :key="key"
      >
        <transition-group name="notify-right">
          <div
            v-html="item.message"
            :class="`ob_notification_item ${item.type}`"
            :key="key"
          />
        </transition-group>
      </div>
    </div>
  </div>
</template>

<script>
  import { events } from './index.js'

  export default {
    name: 'notify',
    data () {
      return {
        all: [],
        isPositionRight: true,
        icons: {
          system_notification_success: 'checked',
          system_notification_error: 'alert',
          system_notification_in_load: 'save',
        }
      }
    },
    mounted () {
      events.$on('ob_add_notification', (params) => {
        this.all.push(params)
        if (!['system_notification_in_load'].includes(params.type)) {
          const timeout = params.timeout || 3000
          setTimeout(() => {
            this.closeNotify(params)
          }, timeout)
        }
      })

      events.$on('ob_close_notification', (params) => {
        this.closeNotify(params)
      })
    },
    computed: {
      rightList () {
        return this.all.filter((it) => {
          if (it.position === 'right') return it
        })
      },
      leftList () {
        return this.all.filter((it) => {
          if (it.position === 'left') return it
        })
      }
    },
    methods: {
      closeNotify (obj) {
        this.all.splice(this.all.findIndex(item => item.id === obj.id), 1)
      },
      actionNotify (obj) {
        obj.onclick.action(obj.onclick.value)
        this.closeNotify(obj)
      }
    }
  }
</script>

<style lang="scss" scoped>
  @import "~common-components/src/static/css/variables";
  @import "~common-components/src/static/css/mixins";

  .ob_notification_container {
    background: red;
    position: fixed;
    bottom: 0;
    left: 0;
    right: 0;
    height: auto;
    display: inline-block;
    max-height: calc(100vh - 104px);
    width: 100%;
    z-index: 3000; // To show notifications over modals (modals have 2000+ zIndexes)

    &_action {
      padding-left: 28px;
      padding-right: 15px;
      font-style: normal;
      font-weight: normal;
      font-size: 16px;
      line-height: 20px;
      text-align: center;
      letter-spacing: 0.4px;
      text-transform: uppercase;
      color: $color-blue-navy-blue;
      cursor: pointer;
    }

    &_right,
    &_left {
      position: absolute;
      bottom: 20px;
      display: inline-block;
      max-width: 50vw;
    }

    &_left {
      left: 20px;
    }

    &_right {
      right: 20px;
    }

    .ob_notification_item_card {
      width: 100%;
      display: inline-block;
      float: left;
    }

    .ob_notification_item {
      border-radius: 3px;
      display: inline-block;

      &.snackbars {
        background: $blue-250;
        box-shadow: 0 4px 16px rgba($blue-700, 0.2);
        padding: 15px 50px 15px 20px;
        @include font-mixin(14px, 20px, 400, $color-text-base, 0);
        position: relative;
        margin-top: 5px;

        i {
          font-family: 'icomoon';
          position: absolute;
          top: 50%;
          transform: translateY(-50%);
          right: 15px;
          font-size: 15px;
          line-height: 12px;
          cursor: pointer;

          &:hover {
            opacity: 0.6;
          }
        }
      }

      &.system_notification_success,
      &.system_notification_error {
        position: relative;
        padding: 3px 10px 3px 30px;
        margin-top: 5px;

        i.icon:before {
          position: absolute;
          top: 50%;
          transform: translateY(-50%);
          left: 10px;
          font-size: 16px;
          font-weight: 700;
          line-height: 16px;
        }
      }


      &.system_notification_in_load {
        @include font-mixin(12px, 20px, 400, $notify-ob_notification_item_system_notification_in_load_font_color, 0);
        background: rgba($color-blue-navy-blue, 0.4);
        position: relative;
        padding: 3px 10px 3px 30px;
        margin-top: 5px;

        .ob_load_animation {
          width: 16px;
          height: 16px;
          position: absolute;
          top: -5px;
          left: 0;
          line-height: 0;
        }
      }

      &.system_notification_success {
        @include font-mixin(12px, 20px, 400, $green-craiola, 0);
        background: rgba($color-green-light, 0.4);
      }

      &.system_notification_error {
        @include font-mixin(12px, 20px, 400, $color-error, 0);
        background: rgba($color-error, 0.4);
      }

      &.warning_red,
      &.warning_blue,
      &.warning_success {
        background: $color-white-lilac;
        float: right;
        padding: 20px 20px 20px 64px;
        @include font-mixin(14px, 20px, 400, $color-text-base, 0.2px);
        width: 360px;
        position: relative;
        border-radius: 0;
        margin-top: 5px;

        &:before {
          font-family: 'icomoon';
          position: absolute;
          top: 20px;
          left: 20px;
          font-size: 24px;
          line-height: 24px;
        }
      }

      &.warning_red {
        &:before {
          content: "\e902";
          color: $color-error;
        }
      }

      &.warning_blue {
        &:before {
          content: "\e902";
          color: $color-blue-navy-blue;
        }
      }

      &.warning_success {
        background: rgba($color-green-light, 0.1);

        &:before {
          content: "\e90c";
          color: $color-green-light;
        }
      }
    }
  }

  .notify-left-enter-active, .notify-left-leave-active {
    transition: all 0.2s;
  }

  .notify-left-enter, .notify-left-leave-to {
    transform: translateX(-10px);
    opacity: 0;
  }

  .notify-right-enter-active, .notify-right-leave-active {
    transition: all 0.2s;
  }

  .notify-right-enter, .notify-right-leave-to {
    transform: translateX(10px);
    opacity: 0;
  }
</style>
